package lt.bit.dao;

import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.LinkedList;
import java.util.List;

import lt.bit.db.MySQL;
import lt.bit.models.Country;

public class CountryDAO {

	public CountryDAO() {

	}

	public List<Country> getCountries() {
		PreparedStatement s;
		try {
			s = MySQL.getConnection().prepareStatement("SELECT * FROM country ORDER BY Name ASC");
			ResultSet r = s.executeQuery();
			List<Country> countries = new LinkedList<>();
			while (r.next()) {
				countries.add(
						new Country(
								r.getString("Code"), 
								r.getString("Name"), 
								r.getString("Continent"),
								r.getString("Region"), 
								r.getDouble("SurfaceArea"), 
								r.getInt("Population"),
								r.getDouble("LifeExpectancy"))
						);
			}
			return countries;

		} catch (SQLException e) {
			e.printStackTrace();
		}
		return null;
	}

	public Country getCountry(String code) {
		PreparedStatement s;
		try {
			s = MySQL.getConnection().prepareStatement("SELECT * FROM country WHERE code=?");

			s.setString(1, code);
			ResultSet r = s.executeQuery();
			r.next();
			return new Country(r.getString("Code"), r.getString("Name"), r.getString("Continent"),
					r.getString("Region"), r.getDouble("SurfaceArea"), r.getInt("Population"),
					r.getDouble("LifeExpectancy"));
		} catch (SQLException e) {
			e.printStackTrace();
		}
		return null;
	}
	
	
	public Country[] getCountriesArray() {
		List<Country> countries=this.getCountries();
		Country[] result=new Country[countries.size()];
		int i=0;
		for(Country c:countries) {
			result[i++]=c;
		}
		return result;
	}

}
